Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.log4j.spi
Interface ErrorHandler

    public interface ErrorHandler

Appenders may delegate their error handling to `ErrorHandlers`.

Error handling is a particularly tedious to get right because by definition errors are hard to predict and to reproduce.

Please take the time to contact the author in case you discover that errors are not properly handled. You are most welcome to suggest new error handling policies or criticize existing policies.

Method Summary
`void` | `error(String message)` This method is normally used to just print the error message passed as a parameter.
`void` | `error(String message, Exception e, int errorCode)` Equivalent to the `error(String, Exception, int, LoggingEvent)` with the the event parameter set to `null`.
`void` | `error(String message, Exception e, int errorCode, LoggingEvent event)` This method is invoked to handle the error.
`void` | `setAppender(Appender appender)` Set the appender for which errors are handled.
`void` | `setBackupAppender(Appender appender)` Set the appender to fallback upon in case of failure.
`void` | `setLogger(Logger logger)` Add a reference to a logger to which the failing appender might be attached to.

Method Detail

### setLogger

    void setLogger(Logger logger)

  Add a reference to a logger to which the failing appender might be attached to. The failing appender will be searched and replaced only in the loggers you add through this method.

  Parameters:
    `logger` - One of the loggers that will be searched for the failing appender in view of replacement.
  Since:
    1.2

### error

    void error(String message,
               Exception e,
               int errorCode)

  Equivalent to the `error(String, Exception, int, LoggingEvent)` with the the event parameter set to `null`.

  Parameters:
    `message` - The message associated with the error.
    `e` - The Exception that was thrown when the error occurred.
    `errorCode` - The error code associated with the error.

### error

    void error(String message)

  This method is normally used to just print the error message passed as a parameter.

  Parameters:
    `message` - The message associated with the error.

### error

    void error(String message,
               Exception e,
               int errorCode,
               LoggingEvent event)

  This method is invoked to handle the error.

  Parameters:
    `message` - The message associated with the error.
    `e` - The Exception that was thrown when the error occurred.
    `errorCode` - The error code associated with the error.
    `event` - The logging event that the failing appender is asked to log.
  Since:
    1.2

### setAppender

    void setAppender(Appender appender)

  Set the appender for which errors are handled. This method is usually called when the error handler is configured.

  Parameters:
    `appender` - The appender
  Since:
    1.2

### setBackupAppender

    void setBackupAppender(Appender appender)

  Set the appender to fallback upon in case of failure.

  Parameters:
    `appender` - The backup appender
  Since:
    1.2

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2015 Apache Software Foundation. All Rights Reserved.
Apache Logging, Apache Log4j, Log4j, Apache, the Apache feather logo, the Apache Logging project logo, and the Apache Log4j logo are trademarks of The Apache Software Foundation.